# -*- coding: cp936 -*-
#python 2.7.14
import sys
import visa
import time
import numpy as np
from openpyxl import load_workbook
from openpyxl.styles import PatternFill, Border, Side, Alignment
from openpyxl.styles import colors, Font, Fill, NamedStyle

rm = visa.ResourceManager()
G6675   = rm.open_resource("GPIB0::31::INSTR")

########## DMM and MFC ##########   
G6675.write("*RST")
G6675.write("*CLS")
G6675.write("RANGELCK OFF")
#G6675.write("OUT 10 V, 0 Hz")
#G6675.write("RANGELCK ON")
G6675.write("STBY") 
G6675.write("OUT 0.0 V, 0 Hz")
G6675.write("EXTGUARD OFF")
time.sleep(5)
G6675.write("OPER")
time.sleep(5)
print "DCC bridge configured"


  
wb = load_workbook('d:\\test_34401.xlsx')
ws = wb.active
time_start = time.time()
dmm.write("TEMP?")
temp_start = float(dmm.read())

########## Colecting info of DMM & Calibrator ##########

########## info of DMM ##########
ws['C5'] = 'Hewlett-Packard'#Manufacturer
dmm.write("ID?")
info = dmm.read()
ws['C6'] = info #Model Number
ws['C7'] = 'HP3458A #2' #Meter info######
dmm.write("OPT?")
info = dmm.read()
ws['C8'] = info #Options
dmm.write("REV?")
info = dmm.read()
ws['C9'] = info #Firmware
ws['C10'] = '03/23/2019' #Last ext. calibration date######
dmm.write("CALNUM?")
info = dmm.read()
ws['C11'] = info #DUT CAL number
dmm.write("CAL? 58")
info = dmm.read()
ws['C12'] = info #CAL?58
dmm.write("CAL? 59")
info = dmm.read()
ws['C13'] = info #CAL?59
dmm.write("CAL? 60")
info = dmm.read()
ws['C14'] = info #CAL?60
dmm.write("CAL? 2941")
info = dmm.read()
ws['C15'] = info #CAL? 2941

ws['H5'] = 'US2823Axxxx' #S/N######
ws['H6'] = '23.0' #Ambient Temperature N######
ws['H7'] = time.strftime("%y-%m-%d %H:%M:%S")#Test date
ws['H8'] = 'verify' #Test Type######
ws['H9'] = 'Test Front Ports' #Notes N###### ROUTe:TERMinals?  returns "FRON" or "REAR"
ws['H10'] = '100' #NPLC######
ws['H11'] = temp_start #DUT Internal TEMP?
dmm.write("CAL? 1,1")
info = dmm.read()
ws['H12'] = info #CAL?1,1
dmm.write("CAL? 72")
info = dmm.read()
ws['H13'] = info #CAL?72
dmm.write("CAL? 2,1")
info = dmm.read()
ws['H14'] = info #CAL?2,1

########## info of Calibrator ##########
ws['A21'] = 'Fluke 5700A EP' #MFC
ws['C21'] = '03 WB' #Option
ws['E21'] = '--' #Unc
ws['F21'] = '--' #Calibraton Date
ws['H21'] = '--' #Due Date
ws['A22'] = 'Fluke 732A#2' #Voltage reference
ws['C22'] = '10.000000 VDC' #Option
ws['E22'] = '--' #Unc
ws['F22'] = '--' #Calibration Date
ws['H22'] = '--' #Due Date
ws['A23'] = 'IET SRL-1' #Resistor standard
ws['C23'] = '1.0000678 ohm' #Option
ws['E23'] = '--' #Unc
ws['F23'] = '--' #Calibration Date
ws['H23'] = '--' #Due Date

ws['A24'] = 'ESI SR-104' #Resistor standard
ws['C24'] = '10.0000125 kohm'#Option
ws['E24'] = '0.3ppm' #Unc
ws['F24'] = '12/18/2015' #Calibration Date
ws['H24'] = '12/18/2016' #Due Date

########## info of MFC ##########
G6675.write("CAL_DATE? CAL")
info = G6675.read()
ws['C29'] = info #
G6675.write("CAL_DATE? WBFLAT")
info = G6675.read()
ws['C30'] = info #
G6675.write("CAL_DATE? WBGAIN")
info = G6675.read()
ws['C31'] = info #
G6675.write("CAL_DATE? ZERO")
info = G6675.read()
ws['C32'] = info #
#G6675.write("CAL_CONF?")#NOT Suport in 5700 
#info = G6675.read()
ws['C33'] = '5720A 99% 24 Hours' #MFC Confidence level N######
G6675.write("CAL_CONST? CHECK, KV6")
info = G6675.read()
ws['C34'] = info #CAL CONST 6.5V reference voltage
G6675.write("CAL_CONST? CHECK, KV13")
info = G6675.read()
ws['C35'] = info #CAL CONST 13V reference voltage
G6675.write("CAL_CONST? CHECK, R10K")
info = G6675.read()
ws['C36'] = info #CAL CONST 10KOHM true output resistance
G6675.write("CAL_CONST? CHECK, RS10K")
info = G6675.read()
ws['C37'] = info #CAL CONST 10KOHM standard resistance
G6675.write("CAL_CONST? CHECK, R1")
info = G6675.read()
ws['C38'] = info #CAL CONST 1 OHM true output resistance
#total number of minutes that the power switch has been on
G6675.write("ETIME?")
info = float(G6675.read())
ws['C39'] = ("%d days " % (info//1440)) + ("%.2f hours" % ((info%1440)/60))
#Returns the number of minutes since power-up this session 
G6675.write("ONTIME?")
info = float(G6675.read())
ws['C40'] = ("%d days " % (info//1440)) + ("%.2f hours" % ((info%1440)/60))

G6675.write("CAL_DAYS? CAL")
info = G6675.read()
ws['H29'] = ("%s days" % (info)) #
G6675.write("CAL_DAYS? WBFLAT")
info = G6675.read()
ws['H30'] = ("%s days" % (info)) #
G6675.write("CAL_DAYS? WBGAIN")
info = G6675.read()
ws['H31'] = ("%s days" % (info)) #
G6675.write("CAL_DAYS? ZERO")
info = G6675.read()
ws['H32'] = ("%s days" % (info)) #
G6675.write("CAL_CONST? CHECK, D3P")
info = float(G6675.read())
ws['H33'] = float("%.7f" % (info)) # #11V range, positive zero
G6675.write("CAL_CONST? CHECK, D3M")
info = float(G6675.read())
ws['H34'] = float("%.7f" % (info))  #11V range, negative zero
G6675.write("CAL_CONST? CHECK, ZERO_TEMP")
info = float(G6675.read())
ws['H35'] = float("%.3f" % (info))  #
G6675.write("CAL_CONST? CHECK, ALL_TEMP")
info = float(G6675.read())
ws['H36'] = float("%.3f" % (info))  #
G6675.write("CAL_CONST? CHECK, WB_FLAT_TEMP")
info = float(G6675.read())
ws['H37'] = float("%.3f" % (info))  #
#G6675.write("CAL_CONST? CHECK, WBAND_TEMP") #NOT Suport in 5700   
#info = G6675.read()
#ws['H38'] = info # 
#G6675.write("CAL TEMP? CHECK")#NOT Suport in 5700 
#info = G6675.read()
#ws['H39'] = info #
G6675.write("CAL_CONST? CHECK, DACLIN")
info = float(G6675.read())
ws['H40'] = float("%.3f" % (info)) #

#to be continue

dmm.write("TEMP?")
temp = float(dmm.read())
ws['B334'] = float("%.1f" % (temp - temp_start))
ws['B333'] = float("%.2f" % ((time.time() - time_start)/60))
wb.save('d:\\test.xlsx')
print("Initialization time elapsed:%.2f minutes, Delta Temp: %.1f Degree"
      % ((time.time() - time_start)/60, (temp - temp_start)))
temp_start = temp
time_start = time.time()

########## DCV PERFORMANCE TEST ##########
### SHORT Input ###
dmm.write("TARM SGL")
volt = float(dmm.read())
if abs(volt) > 1e-3:
    print ("Smoke elapsedd, check connections")
    quit()

#DCV test Zero input
print("OFFSET TESTS (NOTE: Math Null is Disabled)")
for ix in range (0,5):
    array = []
    sdev = 0.0
    median = 0.0
    unc = 0
    
    if ix == 0:
        dmm.write("DCV 0.1")
    if ix == 1:
        dmm.write("DCV 1")
    if ix == 2:
        dmm.write("DCV 10")
    if ix == 3:
        dmm.write("DCV 100")
    if ix == 4:
        dmm.write("DCV 1000")
    for i in range (0,10) :
        dmm.write("TARM SGL")
        volt = float(dmm.read())
        array.extend([volt])
    sdev = np.std(array[1:],ddof = 1)
    median = np.median(array[1:])
    ws['C' + str(47+ix)] = median*1e6
    ws['J' + str(47+ix)] = sdev*1e6
    G6675.write("UNCERT?")
    unc = str(G6675.read())
    ws['K' + str(47+ix)] = unc
    print("Source = %s, dmm = %.8f V,  sdev = %.3f uV,Unc = %s" % ("0 V", median, sdev*1e6, unc))
wb.save('d:\\test.xlsx')

### DCV test 0.01V to 1000V ###
print("DCV GAIN TEST")
DCV_list = [0.01,0.02,0.05,0.10,-0.01,-0.02,-0.05,-0.10,
            0.10,0.20,0.50,1.00,-0.10,-0.20,-0.50,-1.00,
            1.00,2.00,5.00,10.0,-1.00,-2.00,-5.00,-10.0,
            10.0,20.0,50.0,100.0,-10.0,-20.0,-50.0,-100.0,
            -100.0,-200.0,-500.0,-1000.0,100.0,200.0,500.0,1000.0]
    
for ix in range (0,40):
    array = []
    sdev = 0.0
    median = 0.0
    unc = 0
    
    vout = float(DCV_list[ix])
    if abs(vout) <= 0.1 and ix < 8:
        dmm.write("DCV 0.1")
        print("DMM DCV Range: 100mV")
    elif (abs(vout) >= 0.1 and abs(vout) <= 1) and (ix >= 8 and ix < 16):
        dmm.write("DCV 1")
        print("DMM DCV Range: 1V")
    elif (abs(vout) >= 1 and abs(vout) <= 10) and (ix >= 16 and ix < 24):
        dmm.write("DCV 10")
        print("DMM DCV Range: 10V")
    elif (abs(vout) >= 10 and abs(vout) <= 100) and (ix >= 24 and ix < 32):
        dmm.write("DCV 100")
        print("DMM DCV Range: 100V")
    elif (abs(vout) >= 100 and abs(vout) <= 1000) and (ix >= 16 and ix < 40):
        dmm.write("DCV 1000")
        print("DMM DCV Range: 1000V")
    else:
        dmm.write("DCV 1000")
        
    G6675.write("OUT %.7f" % vout)
    G6675.write("OPER")
    time.sleep(5)
    for i in range (0,10):
        dmm.write("TARM SGL")
        volt = float(dmm.read())
        array.extend([volt])
    sdev = np.std(array[1:],ddof = 1)
    median = np.median(array[1:])
    ws['C' + str(53+ix)] = median
    ws['J' + str(53+ix)] = sdev*1e6/median
    G6675.write("UNCERT?")
    unc = str(G6675.read())
    ws['K' + str(53+ix)] = unc
    print("Source = %.3f V, dmm = %.8f V,  sdev = %.3f ppm, Unc = %s" % (vout, median, sdev*1e6/median, unc))    
G6675.write("OUT 250 V, 0 Hz")
time.sleep(5)
G6675.write("OUT 0 V, 0 Hz")
time.sleep(5)
G6675.write("STBY")    

dmm.write("TEMP?")
temp = float(dmm.read())
ws['C333'] = float("%.2f" % ((time.time() - time_start)/60))
ws['C334'] = float("%.1f" % (temp - temp_start))
wb.save('d:\\test.xlsx')
print("DCV time elapsed:%.2f minutes, Delta Temp: %.1f Degree"
      % ((time.time() - time_start)/60, (temp - temp_start))) 
temp_start = temp
time_start = time.time()

########## OHM PERFORMANCE TEST ##########
print("OHM PERFORMANCE TEST")
MFC_OHM_list = ["1 OHM","1.9 OHM","10 OHM","19 OHM","100 OHM","190 OHM","1 KOHM","1.9 KOHM","10 KOHM",
                "19 KOHM","100 KOHM","190 KOHM","1 MOHM","1.9 MOHM","10 MOHM","19 MOHM","100 MOHM","19 MOHM","10 MOHM"]
dmm.write("OCOMP ON") # OCOMP ON at range 10ohm to 10k, OCOMP OFF at range above
dmm.write("DELAY 200E-3") # delay 0.2s at range 10ohm to 10k, default at the rest ranges.
for ix in range (0,19):
    array = []
    sdev = 0.0
    median = 0.0
    cutstr = []
    unc = 0
    
    res = MFC_OHM_list[ix]
    if ix < 3:
        dmm.write("OHMF 10")
        print("DMM OHMF Range: 10 OHM")
    elif ix >= 3 and ix < 5:
        dmm.write("OHMF 100")
        print("DMM OHMF Range: 100 OHM")
    elif ix >= 5 and ix < 7:
        dmm.write("OHMF 1E3")
        print("DMM OHMF Range: 1 KOHM")
    elif ix >= 7 and ix < 9:
        dmm.write("OHMF 1E4")
        print("DMM OHMF Range: 10 KOHM")
    elif ix >= 9 and ix < 11:
        dmm.write("OHMF 1E5")
        dmm.write("OCOMP OFF")
        dmm.write("DELAY -1")         
        print("DMM OHMF Range: 100 KOHM")
    elif ix >= 11 and ix < 13:
        dmm.write("OHMF 1E6")       
        print("DMM OHMF Range: 1 MOHM")
    elif ix >= 13 and ix < 15:
        dmm.write("OHMF 1E7")
        print("DMM OHMF Range: 10 MOHM")
    elif ix == 15:
        dmm.write("OHMF 1E8")
        print("DMM OHMF Range: 100 MOHM")
    elif ix == 16:
        dmm.write("OHM 1E8")
        G6675.write("EXTSENSE OFF")
        print("DMM OHM Range: 100 MOHM")
    elif ix == 17:
        dmm.write("OHM 1E8")
        G6675.write("EXTSENSE OFF")
        print("DMM OHM Range: 100 MOHM")
    elif ix == 18:
        dmm.write("OHM 1E7")
        G6675.write("EXTSENSE OFF")
        print("DMM OHM Range: 10 MOHM")         
    else:
        dmm.write("OHM 1E9")
                
    G6675.write("OUT %s" % res) 
    if ix < 16:
        G6675.write("EXTSENSE ON") 
    G6675.write("OPER")
    if ix < 11:
        time.sleep(10)
    else:
        dmm.write("TRIG AUTO")
        dmm.write("TARM AUTO")        
        time.sleep(120) # waiting 120s at range 1M to 1G
    for i in range (0,20):
        dmm.write("TARM SGL")
        res = float(dmm.read())
        print(res)
        array.extend([res])
    sdev = np.std(array[1:],ddof = 1)
    median = np.median(array[1:])
    G6675.write("OUT?")
    res = G6675.read()
    cutstr = res.split(",")
    ws['B' + str(96+ix)] = float(cutstr[0])
    ws['C' + str(96+ix)] = median
    ws['J' + str(96+ix)] = sdev*1e6/median
    G6675.write("UNCERT?")
    unc = str(G6675.read())
    ws['K' + str(96+ix)] = unc
    print("Source = %s, dmm = %.8f ohm,  sdev = %.3f ppm, Unc = %s" % (cutstr[0], median, sdev*1e6/median, unc))

### OHM zero 4w ###                                                                      
G6675.write("OUT 0 OHM")
G6675.write("EXTSENSE ON")
G6675.write("OPER")
time.sleep(10)
for ix in range (0,9):
    array = []
    sdev = 0.0
    median = 0.0
    unc = 0

    if ix == 0:
        dmm.write("OHMF 10")
        print("DMM OHMF Zero Range: 10 OHM")
    elif ix == 1:
        dmm.write("OHMF 100")
        print("DMM OHMF Zero Range: 100 OHM")
    elif ix == 2:
        dmm.write("OHMF 1E3")
        print("DMM OHMF Zero Range: 1 KOHM")
    elif ix == 3:
        dmm.write("OHMF 1E4")
        print("DMM OHMF Zero Range: 10 KOHM")
    elif ix == 4:
        dmm.write("OHMF 1E5")
        print("DMM OHMF Zero Range: 100 KOHM")
    elif ix == 5:
        dmm.write("OHMF 1E6")
        print("DMM OHMF Zero Range: 1 MOHM")
    elif ix == 6:
        dmm.write("OHMF 1E7")
        print("DMM OHMF Zero Range: 10 MOHM")
    elif ix == 7:
        dmm.write("OHMF 1E8")
        print("DMM OHMF Zero Range: 100 MOHM")
    elif ix == 8:
        dmm.write("OHM 1E9")
        print("DMM OHM Zero Range: 1 GOHM")        
    else:
        dmm.write("OHM 1E9")
        print("DMM OHM Zero Range: 1 GOHM")
    for i in range (0,10):
        dmm.write("TARM SGL")
        res = float(dmm.read())
        array.extend([res])
    sdev = np.std(array[1:],ddof = 1)
    median = np.median(array[1:])

    ws['C' + str(117+ix)] = median
    ws['J' + str(117+ix)] = sdev
    G6675.write("UNCERT?")
    unc = str(G6675.read())
    ws['K' + str(117+ix)] = unc
    print("Source = %s, dmm = %.8f ohm,  sdev = %.3f ohm, Unc = %s" % ("0 ohm", median, sdev, unc))
wb.save('d:\\test.xlsx')
dmm.write("DELAY -1")#RETURNS TO AUTOMATIC (DEFAULT) DELAY

### OHM zero 2w ###
G6675.write("OUT 0 OHM")
G6675.write("EXTSENSE OFF")
G6675.write("OPER")
time.sleep(10)
for ix in range (0,9):
    array = []
    sdev = 0.0
    median = 0.0
    unc = 0

    if ix == 0:
        dmm.write("OHM 10")
        print("DMM OHM Zero Range: 10 OHM")
    elif ix == 1:
        dmm.write("OHM 100")
        print("DMM OHM Zero Range: 100 OHM")
    elif ix == 2:
        dmm.write("OHM 1E3")
        print("DMM OHM Zero Range: 1 KOHM")
    elif ix == 3:
        dmm.write("OHM 1E4")
        print("DMM OHM Zero Range: 10 KOHM")
    elif ix == 4:
        dmm.write("OHM 1E5")
        print("DMM OHM Zero Range: 100 KOHM")
    elif ix == 5:
        dmm.write("OHM 1E6")
        print("DMM OHM Zero Range: 1 MOHM")
    elif ix == 6:
        dmm.write("OHM 1E7")
        print("DMM OHM Zero Range: 10 MOHM")
    elif ix == 7:
        dmm.write("OHM 1E8")
        print("DMM OHM Zero Range: 100 MOHM")
    elif ix == 8:
        dmm.write("OHM 1E9")
        print("DMM OHM Zero Range: 1 GOHM")        
    else:
        dmm.write("OHM 1E9")
        print("DMM OHM Zero Range: 1 GOHM")
    for i in range (0,10):
        dmm.write("TARM SGL")
        res = float(dmm.read())
        array.extend([res])
    sdev = np.std(array[1:],ddof = 1)
    median = np.median(array[1:])
    ws['C' + str(128+ix)] = median
    ws['J' + str(128+ix)] = sdev
    G6675.write("UNCERT?")
    unc = str(G6675.read())
    ws['K' + str(126+ix)] = unc
    print("Source = %s, dmm = %.8f ohm,  sdev = %.3f ohm, Unc = %s" % ("0 ohm", median, sdev, unc))
 
dmm.write("TEMP?")
temp = float(dmm.read())
ws['D333'] = float("%.2f" % ((time.time() - time_start)/60))
ws['D334'] = float("%.2f" % (temp - temp_start))
wb.save('d:\\test.xlsx')
print("OHM time elapsed:%.2f minutes, Delta Temp: %.1f Degree"
      % ((time.time() - time_start)/60, (temp-temp_start)))
temp_start = temp
time_start = time.time()

G6675.write("OUT 0 V, 0 Hz")
G6675.write("STBY")
dmm.write("ACDCV 1000")

########## ACV PERFORMANCE TEST ##########
print("ACV PERFORMANCE TEST")
ACV_ANA_list = ["1 V,50 KHz","1 V, 1 MHz","10 V, 40 Hz","10 V, 200 Hz","10 V, 500 Hz","10 V, 50 KHz","10 V, 1 MHz"]
### ACV ANA Mode ###
dmm.write("ACBAND 10,2E6")#DETector:BANDwidth {3|20|MINimum|MAXimum}
dmm.write("SETACV ANA")
G6675.write("EXTSENSE OFF")

for ix in range (0,7):
    array = []
    sdev = 0.0
    median = 0.0
    unc = 0

    acv = ACV_ANA_list[ix]
    if ix == 6:
        dmm.write("LFILTER OFF")
    else:
        dmm.write("LFILTER ON")
    if ix < 2:
        dmm.write("ACDCV 1")
        print("DMM ACDCV ANA Range: 1V")
    elif ix >= 2:
        dmm.write("ACDCV 10")
        print("DMM ACDCV ANA Range: 10V")
    else:
        dmm.write("ACDCV 1000")
        
    G6675.write("OUT %s" % acv)
    G6675.write("OPER")
    time.sleep(10)
    for i in range (0,10):
        dmm.write("TARM SGL")
        volt = float(dmm.read())
        array.extend([volt])
    sdev = np.std(array[1:],ddof = 1)
    median = np.median(array[1:])
    ws['C' + str(144+ix)] = median
    ws['J' + str(144+ix)] = sdev*1e6/median
    G6675.write("UNCERT?")
    unc = str(G6675.read())
    ws['K' + str(144+ix)] = unc
    print("Source = %s , dmm = %.8f Vac,  sdev = %.3f ppm, Unc = %s" % (acv, median, sdev*1e6/median, unc))    
G6675.write("STBY")        
G6675.write("OUT 10 V, 0 Hz")

### ACV SYNC Mode ###                                                                   
ACV_list = ["0.01 V, 10 Hz","0.01 V, 20 Hz","0.01 V, 40 Hz","0.01 V, 100 Hz","0.01 V, 1 KHz","0.01 V, 10 KHz","0.01 V, 20 KHz","0.01 V, 50 KHz","0.01 V, 100 KHz","0.01 V, 300 KHz","0.01 V, 500 KHz","0.01 V, 1 MHz",
            "0.03 V, 10 Hz","0.03 V, 20 Hz","0.03 V, 40 Hz","0.03 V, 100 Hz","0.03 V, 1 KHz","0.03 V, 10 KHz","0.03 V, 20 KHz","0.03 V, 50 KHz","0.03 V, 100 KHz","0.03 V, 300 KHz","0.03 V, 500 KHz","0.03 V, 1 MHz",
            "0.1 V, 10 Hz","0.1 V, 20 Hz","0.1 V, 40 Hz","0.1 V, 100 Hz","0.1 V, 1 KHz","0.1 V, 10 KHz","0.1 V, 20 KHz","0.1 V, 50 KHz","0.1 V, 100 KHz","0.1 V, 300 KHz","0.1 V, 500 KHz","0.1 V, 1 MHz",
            "0.3 V, 10 Hz","0.3 V, 20 Hz","0.3 V, 40 Hz","0.3 V, 100 Hz","0.3 V, 1 KHz","0.3 V, 10 KHz","0.3 V, 20 KHz","0.3 V, 50 KHz","0.3 V, 100 KHz","0.3 V, 300 KHz","0.3 V, 500 KHz","0.3 V, 1 MHz",            
            "1 V, 10 Hz","1 V, 20 Hz","1 V, 40 Hz","1 V, 100 Hz","1 V, 1 KHz","1 V, 10 KHz","1 V, 20 KHz","1 V, 50 KHz","1 V, 100 KHz","1 V, 300 KHz","1 V, 500 KHz","1 V, 1 MHz",
            "3 V, 10 Hz","3 V, 20 Hz","3 V, 40 Hz","3 V, 100 Hz","3 V, 1 KHz","3 V, 10 KHz","3 V, 20 KHz","3 V, 50 KHz","3 V, 100 KHz","3 V, 300 KHz","3 V, 500 KHz","3 V, 1 MHz",
            "10 V, 10 Hz","10 V, 20 Hz","10 V, 40 Hz","10 V, 100 Hz","10 V, 1 KHz","10 V, 10 KHz","10 V, 20 KHz","10 V, 50 KHz","10 V, 100 KHz","10 V, 300 KHz","10 V, 500 KHz","10 V, 1 MHz",
            "30 V, 10 Hz","30 V, 20 Hz","30 V, 40 Hz","30 V, 100 Hz","30 V, 1 KHz","30 V, 10 KHz","30 V, 20 KHz","30 V, 50 KHz","30 V, 100 KHz","30 V, 300 KHz","30 V, 500 KHz",
            "100 V, 10 Hz","100 V, 20 Hz","100 V, 40 Hz","100 V, 100 Hz","100 V, 1 KHz","100 V, 10 KHz","100 V, 20 KHz","100 V, 50 KHz","100 V, 100 KHz",
            "300 V, 100 Hz","300 V, 200 Hz","300 V, 400 Hz","300 V, 500 Hz","300 V, 1 KHz","750 V, 1 KHz"]

dmm.write("ACBAND 10,2E6")
dmm.write("SETACV SYNC")
for ix in range (0,110):
    array = []
    sdev = 0.0
    median = 0.0
    cutstr = []
    unc = 0
    
    if (ix>7 and ix<12) or (ix>19 and ix<24) or (ix>31 and ix<36) or (ix>43 and ix<48) or (ix>55 and ix<60):
        dmm.write("LFILTER OFF")
    elif (ix>67 and ix<72) or (ix>79 and ix<84) or (ix>91 and ix<95) or ix==103:
        dmm.write("LFILTER OFF")    
    else:
        dmm.write("LFILTER ON")
        
    acv = ACV_list[ix]
    cutstr = acv.split(" ")
    if ix < 12:
        dmm.write("ACDCV 0.01")
        print("DMM ACDCV SYNC Range: 10mVAC")
    elif ix >= 12 and ix < 36 and float(cutstr[0]) < 0.12:
        dmm.write("ACDCV 0.1")
        print("DMM ACDCV SYNC Range: 100mVAC")
    elif ix >= 36 and ix < 60 and float(cutstr[0]) < 1.2:
        dmm.write("ACDCV 1")
        print("DMM ACDCV SYNC Range: 1V")
    elif ix >= 60 and ix < 84 and float(cutstr[0]) < 12:
        dmm.write("ACDCV 10")
        print("DMM ACDCV SYNC Range: 10V")
    elif ix >= 84 and ix < 104 and float(cutstr[0]) < 120:
        dmm.write("ACDCV 100")
        print("DMM ACDCV SYNC Range: 100V")
    else:
        dmm.write("ACDCV 1000")
        print("DMM ACDCV SYNC Range: 1000V")
        
    G6675.write("OUT %s" % acv)
    G6675.write("OPER")
    time.sleep(10)
    for i in range (0,10):
        dmm.write("TARM SGL")
        volt = float(dmm.read())
        array.extend([volt])
    sdev = np.std(array[1:],ddof = 1)
    median = np.median(array[1:])
    ws['C' + str(153+ix)] = median
    ws['J' + str(153+ix)] = sdev*1e6/median
    G6675.write("UNCERT?")
    unc = str(G6675.read())
    ws['K' + str(153+ix)] = unc
    print("Source = %s , dmm = %.8f Vac,  sdev = %.3f ppm, Unc = %s" % (acv, median, sdev*1e6/median, unc))
G6675.write("OUT 250 V, 1 KHz")
time.sleep(5)
G6675.write("OUT 0 V, 0 Hz")
time.sleep(5)
G6675.write("STBY")

dmm.write("TEMP?")
temp = float(dmm.read())
ws['E333'] = float("%.2f" % ((time.time() - time_start)/60))
ws['E334'] = float("%.1f" % (temp - temp_start))
wb.save('d:\\test.xlsx')
print("ACV time elapsed:%.2f minutes, Delta Temp: %.1f Degree"
      %((time.time() - time_start)/60, (temp-temp_start)))
temp_start = temp


#########################
#remove all cable and short bar, connect a Twisted pair cable for current testing
while 1:
    str_input = raw_input("Reconnect the cable for Current testing, and then input:Continue testing")
    if cmp(str_input,'Continue testing') == 0:
        break
    else:
        print("input again")
#########################
      
time_start = time.time()        
########## DCI test 100nA to 1A ##########
print("DCI PERFORMANCE TEST")
DCI_list = ["0 uA","0.05 uA","0.1 uA","-0.1 uA","-0.05 uA","0 uA","0.5 uA","1 uA","-1 uA","-0.5 uA",
            "0 uA","5 uA","10 uA","-10 uA","-5 uA","0 uA","50 uA","100 uA","-100 uA","-50 uA",
            "0 uA","0.5 mA","1 mA","-1 mA","-0.5 mA","0 mA","5 mA","10 mA","-10 mA","-5 mA",
            "0 mA","50 mA","100 mA","-100 mA","-50 mA","0 mA","0.5 A","1 A","-1 A","-0.5 A"]

G6675.write("OUT 0 uA, 0 Hz")
G6675.write("CUR_POST AUX")
for ix in range (0,40):
    array = []
    sdev = 0.0
    median = 0.0
    unc = 0

    iout = DCI_list[ix]
    if ix < 5:
        dmm.write("DCI 100E-9")
        print("DMM DCI Range: 100nA")
    elif ix >= 5 and ix < 10:
        dmm.write("DCI 1E-6")
        print("DMM DCI Range: 1uA")
    elif ix >= 10 and ix < 15:
        dmm.write("DCI 10E-6")
        print("DMM DCI Range: 10uA")
    elif ix >= 15 and ix < 20:
        dmm.write("DCI 100E-6")
        print("DMM DCI Range: 100uA")
    elif ix >= 20 and ix < 25:
        dmm.write("DCI 1E-3")
        print("DMM DCI Range: 1mA")
    elif ix >= 25 and ix < 30:
        dmm.write("DCI 1E-2")
        print("DMM DCI Range: 10mA")
    elif ix >= 30 and ix < 35:
        dmm.write("DCI 0.1")
        print("DMM DCI Range: 100mA")
    elif ix >= 35 and ix < 40:
        dmm.write("DCI 1")
        print("DMM DCI Range: 1A")        
    else:
        dmm.write("DCI 1")
        
    G6675.write("OUT %s" % iout)
    G6675.write("OPER")
    time.sleep(10)
    for i in range (0,10):
        dmm.write("TARM SGL")
        volt = float(dmm.read())
        array.extend([volt])
    sdev = np.std(array[1:],ddof = 1)
    median = np.median(array[1:])
    ws['C' + str(270+ix)] = median
    ws['J' + str(270+ix)] = sdev*1e6/median
    G6675.write("UNCERT?")
    unc = str(G6675.read())
    ws['K' + str(270+ix)] = unc
    print("Source = %s, dmm = %.8f A,  sdev = %.3f ppm, Unc = %s" % (iout, median, sdev*1e6/median, unc))
wb.save('d:\\test.xlsx')
G6675.write("OUT 0 uA, 0 Hz")

dmm.write("TEMP?")
temp = float(dmm.read())
ws['F333'] = float("%.2f" % ((time.time() - time_start)/60))
ws['F334'] = float("%.1f" % (temp - temp_start))
wb.save('d:\\test.xlsx')
print("DCI time elapsed:%.2f minutes Delta Temp: %.1f Degree"
      % ((time.time() - time_start)/60, (temp-temp_start)))
temp_start = temp
time_start = time.time()

########## ACI test 10uA to 1A ##########
ACI_list = ["10 uA, 50 Hz","10 uA, 60 Hz","10 uA, 1 kHz",
            "100 uA, 50 Hz","100 uA, 60 Hz","100 uA, 1 kHz",
            "1 mA, 50 Hz","1 mA, 60 Hz","1 mA, 1 kHz",
            "10 mA, 50 Hz","10 mA, 60 Hz","10 mA, 1 kHz",
            "100 mA, 50 Hz","100 mA, 60 Hz","100 mA, 1 kHz",
            "1 A, 50 Hz","1 A, 60 Hz","1 A, 1 kHz"]
for ix in range (0,18):
    array = []
    sdev = 0.0
    median = 0.0
    unc = 0

    iout = ACI_list[ix]
    if ix < 6:
        dmm.write("ACI 100E-6")
        print("DMM ACI Range: 100uA")
    elif ix >= 6 and ix < 9:
        dmm.write("ACI 1E-3")
        print("DMM ACI Range: 1mA")
    elif ix >= 9 and ix < 12:
        dmm.write("ACI 10E-3")
        print("DMM ACI Range: 10mA")
    elif ix >= 12 and ix < 15:
        dmm.write("ACI 0.1")
        print("DMM ACI Range: 100mA")
    elif ix >= 15 and ix < 18:
        dmm.write("ACI 1")
        print("DMM ACI Range: 1A")         
    else:
        dmm.write("ACI 1")
        
    G6675.write("OUT %s" % iout)
    G6675.write("OPER")
    time.sleep(10)
    for i in range (0,10):
        dmm.write("TARM SGL")
        volt = float(dmm.read())
        array.extend([volt])
    sdev = np.std(array[1:],ddof = 1)
    median = np.median(array[1:])
    ws['C' + str(313+ix)] = median
    ws['J' + str(313+ix)] = sdev*1e6/median
    G6675.write("UNCERT?")
    unc = str(G6675.read())
    ws['K' + str(313+ix)] = unc
    print("Source = %s, dmm = %.8f A,  sdev = %.3f ppm, Unc = %s" % (iout, median, sdev*1e6/median, unc))
   
dmm.write("TEMP?")
temp = float(dmm.read())
ws['G333'] = float("%.2f" % ((time.time() - time_start)/60))
ws['G334'] = float("%.1f" % (temp - temp_start))
wb.save('d:\\test.xlsx')
print("ACI time elapsed:%.2f minutes Delta Temp: %.1f Degree"
      % ((time.time() - time_start)/60, (temp - temp_start)))

#Calibration Test Results Summary
dmm.write("CAL? 2941")
info = dmm.read()
ws['H15'] = info #CAL? 2941
#to be continue
wb.save('d:\\test.xlsx')

#Reset the DMM and MFC####
G6675.write("OUT 0 V, 0 Hz")
G6675.write("STBY")
G6675.write("*RST")
G6675.write("*CLS")
G6675.write("OUT 0 V, 0 Hz")     
G6675.write("RANGELCK ON")
dmm.write("RESET")
dmm.write("END ALWAYS")
dmm.write("DCV 1000")




